import { SyncLiveQuery } from '@orbit/record-cache';
import { RecordQuery, RecordQueryResult } from '@orbit/records';
import Cache from './cache';
import { Model } from 'ember-orbit';
export interface LiveQuerySettings {
    liveQuery: SyncLiveQuery;
    query: RecordQuery;
    cache: Cache;
}
export default class LiveQuery implements Iterable<Model> {
    #private;
    _invalidate: number;
    constructor(settings: LiveQuerySettings);
    get query(): RecordQuery;
    /**
     * @deprecated
     */
    get content(): RecordQueryResult<Model>;
    get value(): RecordQueryResult<Model>;
    get length(): number;
    [Symbol.iterator](): IterableIterator<Model>;
    destroy(): void;
}
